var search_data = {"index":{"searchIndex":["danom","default","just","cannotbenil","maybe","monad","object","default()","just()","maybe()","and_then()","and_then()","and_then()","continue()","method_missing()","monad_value()","monad_value()","monad_value()","new()","new()","new()","respond_to_missing?()","value()"],"longSearchIndex":["danom","danom::default","danom::just","danom::just::cannotbenil","danom::maybe","danom::monad","object","object#default()","object#just()","object#maybe()","danom::default#and_then()","danom::just#and_then()","danom::maybe#and_then()","danom::maybe#continue()","danom::monad#method_missing()","danom::default#monad_value()","danom::just#monad_value()","danom::monad#monad_value()","danom::default::new()","danom::just::new()","danom::monad::new()","danom::monad#respond_to_missing?()","danom::monad#value()"],"info":[["Danom","","Danom.html","","<p>@nodoc\n"],["Danom::Default","","Danom/Default.html","","<p>A default “monad”. Not technically a monad as it take two values.\n"],["Danom::Just","","Danom/Just.html","","<p>Useful for immediately failing when a nil pops up.\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">name</span> = <span class=\"ruby-identifier\">get_name</span>(<span class=\"ruby-identifier\">person</span>) <span class=\"ruby-comment\">#=&gt; nil</span>\n<span class=\"ruby-comment\"># ... later somewhere ...</span>\n</pre>\n"],["Danom::Just::CannotBeNil","","Danom/Just/CannotBeNil.html","","<p>Raised if the underlying value of Just becomes nil\n"],["Danom::Maybe","","Danom/Maybe.html","",""],["Danom::Monad","","Danom/Monad.html","","<p>This class provides a common interface.\n<p>@abstract\n"],["Object","","Object.html","",""],["Default","Object","Object.html#method-i-Default","(fallback, value)",""],["Just","Object","Object.html#method-i-Just","(value)",""],["Maybe","Object","Object.html#method-i-Maybe","(value)",""],["and_then","Danom::Default","Danom/Default.html#method-i-and_then","(&block)","<p>Allows chaining on nil values with a fallback\n<p>@note The fallback does not get the transformations\n<p>@example …\n"],["and_then","Danom::Just","Danom/Just.html#method-i-and_then","(&block)","<p>Similar to Maybe#and_then but raises an error if the value ever becomes nil.\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">j</span> = <span class=\"ruby-constant\">Just</span>(<span class=\"ruby-string\">&#39;hello&#39;</span>) <span class=\"ruby-operator\">...</span>\n</pre>\n"],["and_then","Danom::Maybe","Danom/Maybe.html#method-i-and_then","()","<p>Allows for safe navigation on nil.\n\n<pre class=\"ruby\"><span class=\"ruby-keyword\">nil</span>&amp;.<span class=\"ruby-identifier\">m1</span>&amp;.<span class=\"ruby-identifier\">m2</span>&amp;.<span class=\"ruby-identifier\">m3</span> <span class=\"ruby-comment\">#=&gt; nil</span>\n\n<span class=\"ruby-operator\">~</span><span class=\"ruby-constant\">Maybe</span>(<span class=\"ruby-keyword\">nil</span>).<span class=\"ruby-identifier\">m1</span>.<span class=\"ruby-identifier\">m2</span>.<span class=\"ruby-identifier\">m3</span> <span class=\"ruby-comment\">#=&gt; nil</span>\n</pre>\n<p>Using a Maybe …\n"],["continue","Danom::Maybe","Danom/Maybe.html#method-i-continue","()","<p>“Fails” a maybe given a certain condition. If the condition is `false` then Maybe(nil) will …\n"],["method_missing","Danom::Monad","Danom/Monad.html#method-i-method_missing","(method, *args, &block)","<p>Provides convinience for chaining methods together while maintaining a monad.\n<p>@example Chaining fetches …\n"],["monad_value","Danom::Default","Danom/Default.html#method-i-monad_value","()","<p>@override\n"],["monad_value","Danom::Just","Danom/Just.html#method-i-monad_value","()","<p>@raise [Danom::Just::CannotBeNil]\n"],["monad_value","Danom::Monad","Danom/Monad.html#method-i-monad_value","()","<p>Extract the value from the monad. Can also be extracted via `~` unary operator.\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-operator\">~</span><span class=\"ruby-constant\">Maybe</span>(<span class=\"ruby-string\">&quot;hello&quot;</span>) <span class=\"ruby-operator\">...</span>\n</pre>\n"],["new","Danom::Default","Danom/Default.html#method-c-new","(fallback, value)","<p>@param fallback [Object] The value on which to fallback if the doesn&#39;t\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">satisfy</span> <span class=\"ruby-constant\">Just</span>(<span class=\"ruby-identifier\">value</span>)\n</pre>\n<p>@param value …\n"],["new","Danom::Just","Danom/Just.html#method-c-new","(value)","<p>@raise [Danom::Just::CannotBeNil] if value is provided as nil\n"],["new","Danom::Monad","Danom/Monad.html#method-c-new","(value)",""],["respond_to_missing?","Danom::Monad","Danom/Monad.html#method-i-respond_to_missing-3F","(method_name, include_private = false)",""],["value","Danom::Monad","Danom/Monad.html#method-i-value","()","<p>Extract the value from the monad. If the underlying value responds to #value then this will be bypassed …\n"]]}}